function AxonReconstructions()
clear; clc; 

fn = 'C:\Users\economom\Dropbox (HHMI)\code\PTtagging\AnalysisForFigures\PTcells-MDhighlighted.mat';
load(fn);

in.IDs = {};
in.grnum = [];
in.clr = [];


in.IDs{end+1} = 'AA0180'; in.grnum(end+1) = 1; in.clr(end+1, :) = [1 0 1];
in.IDs{end+1} = 'AA0179'; in.grnum(end+1) = 1; in.clr(end+1, :) = [0.75 0.25 0.75];
in.IDs{end+1} = 'AA0133'; in.grnum(end+1) = 1; in.clr(end+1, :) = [0.25 0 0.25];
in.IDs{end+1} = 'AA0012'; in.grnum(end+1) = 1; in.clr(end+1, :) = [0.4 0 0.6];


in.IDs{end+1} = 'AA0181'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0 1 0];
in.IDs{end+1} = 'AA0182'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0.5 0.7 0];
in.IDs{end+1} = 'AA0245'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0 0.5 0];
in.IDs{end+1} = 'AA0011'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0.1 0.7 0.1];
in.IDs{end+1} = 'AA0261'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0.5 0.8 0];
in.IDs{end+1} = 'AA0122'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0.4 0.9 0]; 
in.IDs{end+1} = 'AA0115'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0.4 0.9 0]; 
in.IDs{end+1} = 'AA0114'; in.grnum(end+1) = 2; in.clr(end+1, :) = [0.4 0.9 0];




MTStructs = {'Thalamus'; ...
    'Parafascicular nucleus'; ...
    'Ventral group of the dorsal thalamus'; ...
    'Medial group of the dorsal thalamus';
    
    'Medulla'; ...
    'Intermediate reticular nucleus';...
    'Medullary reticular nucleus'; ...
    'Parvicellular reticular nucleus';};

OtherStructs = {'Caudoputamen';...
    'Superior colliculus motor related';...
    'Pons'; ...
    'Pontine gray'; ...
};


for i = 1:numel(Session.Neurons)
   if ~isempty(strfind(Session.Neurons(i).Name, '-A'))
       disp(Session.Neurons(i).Name)
   end
    
end


plotObjs(Session, in, [3 2 1])
plotObjs(Session, in, [3 1 2])


st = quantifyStructures(Session, in);

dispStats(st, in, 'root');
dispBars(st, in, MTStructs);
dispBars(st, in, OtherStructs);

dispAllTargets(st, in)







function dispStats(st, in, structname)

row = find(strcmp(st.names, structname));
disp(['TERMINI: ' st.names{row} ' - Med:  ' num2str(round(st.ends(row,in.grnum==1))) '; Thal:  ' num2str(round(st.ends(row,in.grnum==2))) ]);
disp(['All: ' num2str(median(st.ends(row,:))) ' +/- ' num2str(std(st.ends(row,:))./sqrt(numel(in.grnum)))]);
disp(['Med: ' num2str(median(st.ends(row,in.grnum==1))) ' +/- ' num2str(std(st.ends(row,in.grnum==1))./sqrt(sum(in.grnum==1)))]);
disp(['Thal: ' num2str(median(st.ends(row,in.grnum==2))) ' +/- ' num2str(std(st.ends(row,in.grnum==2))./sqrt(sum(in.grnum==2)))]);
disp(' ');

disp(['LENGTH: ' st.names{row} ' - Med:  ' num2str(round(st.lens(row,in.grnum==1))) '; Thal:  ' num2str(round(st.lens(row,in.grnum==2))) ]);
disp(['All: ' num2str(median(st.lens(row,:))) ' +/- ' num2str(std(st.lens(row,:))./sqrt(numel(in.grnum)))]);
disp(['Med: ' num2str(median(st.lens(row,in.grnum==1))) ' +/- ' num2str(std(st.lens(row,in.grnum==1))./sqrt(sum(in.grnum==1)))]);
disp(['Thal: ' num2str(median(st.lens(row,in.grnum==2))) ' +/- ' num2str(std(st.lens(row,in.grnum==2))./sqrt(sum(in.grnum==2)))]);


     


function dispAllTargets(st, in)
Nstruct = numel(st.names);

vals = st.lens;
% vals = median(st.lens(:, in.grnum==1), 2)./(median(st.lens(:, in.grnum==2), 2)+0.001);
[~, ix] = sort(sum(vals, 2), 'ascend');

for i = 1:Nstruct
    disp([st.names{ix(i)} ' - Med:  ' num2str(round(st.lens(ix(i),in.grnum==1))) '; Thal:  ' num2str(round(st.lens(ix(i),in.grnum==2))) ]);
end



function dispBars(st, in, displayStructs)


Ndisp = numel(displayStructs);

uniquenums = unique(in.grnum);
Ngr = numel(uniquenums);
figure; hold on;
set(gcf, 'Units', 'Normalized', 'Position', [0.29 0.11 0.42 0.79]);
for i = 1:Ndisp
    row = find(strcmp(st.names, displayStructs{i}), 1, 'first');
    
    if ~isempty(row)
        for j = 1:Ngr
            plot(i+0.5+0.1*j+0.05*randn(sum(in.grnum==uniquenums(j)), 1), max(0, st.ends(row, in.grnum==uniquenums(j))), 'o', 'MarkerFaceColor', getClr(uniquenums(j), 0), 'MarkerEdgeColor', [1 1 1], 'MarkerSize',  10, 'Linewidth', 1);
        end
    else
        disp(['Did not find structure: ' displayStructs{i}]);
    end
end
set(gca, 'Xtick', 0.5+(1:Ndisp), 'XtickLabel', displayStructs, 'XtickLabelRotation', 45, 'YScale', 'linear');
ylabel('Axonal Termini');
set(gca, 'FontSize', 12);
yl = ylim();
ylim([0 yl(2)]);


for j = 1:Ndisp
    f = fill([j j+1 j+1 j], [yl(1) yl(1) yl(2) yl(2)], [0 0 0]);
    set(f, 'LineStyle', 'none', 'FaceAlpha', 0.05+0.05*mod(j,2));
    
end


title('TERMINI');




Ndisp = numel(displayStructs);

uniquenums = unique(in.grnum);
Ngr = numel(uniquenums);
figure; hold on;
set(gcf, 'Units', 'Normalized', 'Position', [0.32 0.11 0.42 0.79]);
% hues = (1:numel(in.grnum))./numel(in.grnum);
for i = 1:Ndisp
    row = find(strcmp(st.names, displayStructs{i}), 1, 'first');
    
    if ~isempty(row)
        for j = 1:Ngr
            plot(i+0.5+0.1*j+0.05*randn(sum(in.grnum==uniquenums(j)), 1), max(0, st.lens(row, in.grnum==uniquenums(j))), 'o', 'MarkerFaceColor', getClr(uniquenums(j), 0), 'MarkerEdgeColor', [1 1 1], 'MarkerSize',  10, 'Linewidth', 1);
            
        end
%         for j = 1:Ngr
%             for k = [14 18]
%                 edgeclr = [0 0 0];
%                 edgeclr(in.grnum(k)) = 1;
%                 plot(i+0.5+0.001*k+0.05*randn(1), max(0, st.lens(row, k)), 'o', 'MarkerFaceColor', hsv2rgb([hues(k), 1, 0.5]), 'MarkerEdgeColor', edgeclr, 'MarkerSize',  10, 'Linewidth', 1);
%             end
%         end
%         
    else
        disp(['Did not find structure: ' displayStructs{i}]);
    end
end


set(gca, 'Xtick', 0.5+(1:Ndisp), 'XtickLabel', displayStructs, 'XtickLabelRotation', 45, 'Yscale', 'linear');
ylabel('Axonal length (mm)');
set(gca, 'FontSize', 12);
yl = ylim();
ylim([0 yl(2)]);

for j = 1:Ndisp
    f = fill([j j+1 j+1 j], [yl(1) yl(1) yl(2) yl(2)], [0 0 0]);
    set(f, 'LineStyle', 'none', 'FaceAlpha', 0.05+0.05*mod(j,2));
    
end

rowT = find(strcmp(st.names, 'Thalamus'), 1, 'first');
rowIRN = find(strcmp(st.names, 'Intermediate reticular nucleus'), 1, 'first');
rowPRN = find(strcmp(st.names, 'Parvicellular reticular nucleus'), 1, 'first');
rowMMR = find(strcmp(st.names, 'Medulla motor related'), 1, 'first'); 
rowMSR = find(strcmp(st.names, 'Medulla sensory related'), 1, 'first'); 



title('AXONAL LENGTH');






function out = quantifyStructures(Session, in)
Ncells = numel(in.IDs);   
Nobj = numel(Session.Neurons);
AxonOnly = 1;

structlist = [];
for i = 1:Ncells
    for j = 1:Nobj
        nu = Session.Neurons(j);

        if ~isempty(strfind(nu.Name, in.IDs{i}))
            Npts = numel(nu.Anatomy);
            
            for k = 1:Npts
                an = nu.Anatomy(k);
                
                if ~isempty(an.structureIdPath)
                    
                    structNums = str2double(strsplit(an.structureIdPath, '/'));
                    structNums = structNums(~isnan(structNums));
                    
                    structlist = union(structlist, structNums);
                end
            end
        end
    end
end

Nstruct = numel(structlist);
structlens = zeros(Nstruct, Ncells);
structnames = cell(Nstruct, 1);
numends = zeros(Nstruct, Ncells);
for i = 1:Ncells
    for j = 1:Nobj
        
        nu = Session.Neurons(j);
        pos = DisplayData(nu);
        nodeNums = pos(:,5);
        len = sqrt(sum((pos(1:end-1,1:3)./1000 - pos(2:end, 1:3)./1000).^2, 2));
       
        if ~isempty(strfind(nu.Name, in.IDs{i}))
            if ~isempty(strfind(nu.Name, '-D')) && AxonOnly
                continue;
            end
            
            Npts = numel(nu.Anatomy);
           
            for k = 1:Npts
                an = nu.Anatomy(k);
                
%                 parents = unique(nu.Nodes(:,4));
                endpts = setxor(nu.Nodes(:,4), nu.Nodes(:,5));
                
                if ~isempty(an.structureIdPath)
                    
                    structNums = str2double(strsplit(an.structureIdPath, '/'));
                    structNums = structNums(~isnan(structNums));
                    
                    [~, ix] = ismember(structNums, structlist);
                    
                    row = find(nu.Nodes(k,5)==nodeNums, 1, 'first');
                    
                    thislen = len(row);
                    thislen(isnan(thislen))=0;
                    
                    structlens(ix, i) = structlens(ix, i)+thislen;

                    structnames{structlist==an.structureId} = an.safeName;
                    
                    if ismember(nu.Nodes(k, 5), endpts)
                        
                        numends(ix, i) = numends(ix,i)+1;
                        
                        
                    end
                    
                    
                end

            end
            
        end
    end
end



out.names = structnames;
out.lens = structlens;
out.ends = numends;
out.AxonOnly = AxonOnly;


    












function len = plotObjs(Session, in, axorder)
Ncells = numel(in.IDs);   
Nobj = numel(Session.Neurons);


figure; hold on;
len = zeros(Ncells, 1);
branchnum = zeros(Ncells, 1);
for i = 1:Ncells
    
    for j = 1:Nobj
    
        nu = Session.Neurons(j);
        
        if ~isempty(strfind(nu.Name, in.IDs{i}))
            
            if ~isempty(strfind(nu.Name, '-D'))
                sz = 1.2;
            else
%                 continue;
                sz = 0.6;
            end
            
            pos = DisplayData(nu);
            
            plot3(pos(:,axorder(1))./10, pos(:,axorder(2))./10, pos(:,axorder(3))./10, '-', 'Color', in.clr(i,:), 'LineWidth', sz)
            diffpos = diff(pos./1000, [], 1);
            branchnum(i) = branchnum(i)+sum(isnan(pos(:,1).*2), 1);
            len(i) = len(i)+nansum(sqrt(sum(diffpos.^2, 2)), 1);
            
            
        end

    end
    
end
lims = [0 1140; 0 800; 0 1320];
for i = 1:2
    for j = 1:2
        for k = 1:2
            plot3(lims(axorder(1),i), lims(axorder(2),j), lims(axorder(3),k), 'kx', 'MarkerSize', 1);
            plot3(lims(axorder(1),i)*1.1, lims(axorder(2),j)*1.1, lims(axorder(3),k)*1.1, 'ko', 'MarkerSize', 1);
        end
    end
end


% xlim(lims(axorder==1, :));
% ylim(lims(axorder==2, :));
% zlim(lims(axorder==3, :));

set(gca, 'YDir', 'Reverse');
axis equal;
% xlabel('x');
% ylabel('y');
% zlabel('z');




function data = DisplayData(obj)
% Initialize.
paths = {}; %hold compelted paths.
nextNode = 1; %next node in path
pathCounter = 1;
nodeCounter = 1;
while ~isempty(nextNode)
   % Store current point.
   paths{pathCounter}(nodeCounter) = nextNode;
   nodeCounter = nodeCounter +1;
   % Find first connected node.
   nextNode = find(obj.Nodes(:,4) == nextNode,1);
   % if end of path.
   if isempty(nextNode)
       % next path.
       pathCounter = pathCounter + 1;
       nodeCounter = 1;
       % Find first point not in list.
       nextNode=find(~ismember(1:size(obj.Nodes,1),[paths{:}]),1);
       % if there is another path.
       if ~isempty(nextNode)
           % store first point for connectivity.
           paths{pathCounter}(nodeCounter) = obj.Nodes(nextNode,4);
           nodeCounter = nodeCounter +1;
       end
   end
end

% Get display data.
data = cellfun(@(x) [obj.Nodes(x,1:5);NaN,NaN,NaN,NaN,NaN]',paths,'UniformOutput',false);
data = [data{:}]';












